Unit qsfpe_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure qsfpe(FUN :Func_F1CE; A :Extended; B :Extended; ABSERR :Extended;
                RELERR :Extended; T :Extended; var RESULT_ :Extended;
                var ERREST :Extended; var NOFUN :Integer;
                var FLAG :Extended);

implementation

procedure qsfpe(FUN :Func_F1CE; A :Extended; B :Extended; ABSERR :Extended;
                RELERR :Extended; T :Extended; var RESULT_ :Extended;
                var ERREST :Extended; var NOFUN :Integer;
                var FLAG :Extended);
var
I,J,LEV,LEVMAX,LEVMIN,LEVOUT,NIM,NOFIN,NOMAX :Integer;
ALFA,AREA,BETA,C15,C16,C7,C8,COR11,CS0,ESTERR,FI0,FR0,GAMA,QDIFF,
   QLEFT,QNOW,QPREV,S15,S16,S7,S8,SN0,STEP,STONE,TA,TB,TC,TEMP,TOLERR,
   TT,X0 :Extended;
F0,F1,FJ,ZI :Complex;
CS :Array [0..15] of Extended;
FI :Array [0..15] of Extended;
FISAVE :Array [0..239] of Extended;
FR :Array [0..15] of Extended;
FRSAVE :Array [0..239] of Extended;
QRIGHT :Array [0..30] of Extended;
SN :Array [0..15] of Extended;
X :Array [0..15] of Extended;
XSAVE :Array [0..239] of Extended;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220;
begin
ZI  := Cmplx(0.e0,1.e0);
LEVMIN  := 1;
LEVMAX  := 30;
LEVOUT  := 6;
NOMAX  := 5000;
NOFIN  := Trunc(NOMAX - 8*(LEVMAX - LEVOUT + IntPower(2,LEVOUT + 1)));
FLAG  := 0.e0;
RESULT_  := 0.0e0;
COR11  := 0.0e0;
ERREST  := 0.0e0;
AREA  := 0.0e0;
NOFUN  := 0;
if ( A  =  B ) 
 then goto _220;
LEV  := 0;
NIM  := 1;
X0  := A;
X[15] := B;
QPREV  := 0.0e0;
F0  := FUN(X0);
FR0  := Creal(F0);
FI0  := Creal(MulC(SubC(Cmplx(0.0,0.0),ZI),FUN(X0)));
STONE  := (B - A)/16.0e0;
X[7] := (X0 + X[15])/2.0e0;
X[3] := (X0 + X[7])/2.0e0;
X[11] := (X[7] + X[15])/2.0e0;
X[1] := (X0 + X[3])/2.0e0;
X[5] := (X[3] + X[7])/2.0e0;
X[9] := (X[7] + X[11])/2.0e0;
X[13] := (X[11] + X[15])/2.0e0;
J := 2;
while ( J<=16 ) do
 begin
  FJ  := FUN(X[J-1]);
  FR[J-1] := Creal(FJ);
  FI[J-1] := Creal(MulC(SubC(Cmplx(0.0,0.0),ZI),FJ));
_10:
  inc(J,2);
 end;
NOFUN  := 9;
_20:
X[0] := (X0 + X[1])/2.0e0;
F1  := FUN(X[0]);
FR[0] := Creal(F1);
FI[0] := Creal(MulC(SubC(Cmplx(0.0,0.0),ZI),F1));
J := 3;
while ( J<=15 ) do
 begin
  X[J-1] := (X[J-2] + X[J+0])/2.0e0;
  FJ  := FUN(X[J-1]);
  FR[J-1] := Creal(FJ);
  FI[J-1] := Creal(MulC(SubC(Cmplx(0.0,0.0),ZI),FJ));
_30:
  inc(J,2);
 end;
NOFUN  := NOFUN + 8;
STEP  := (X[15] - X0)/16.0e0;
TT  := T*STEP;
if ( TT  <=  0.001e0 ) 
 then goto _40;
TA  := Sin(2.e0*TT);
TB  := Sin(TT);
TC  := Cos(TT);
ALFA  := (1.e0 + TA/(2.e0*TT) - 2.e0*IntPower(TB/TT,2))/TT;
BETA  := 2.e0*(1.e0 + IntPower(TC,2) - TA/TT)/(IntPower(TT,2));
GAMA  := 4.e0*(TB/TT - TC)/(IntPower(TT,2));
goto _50;
_40:
ALFA  := 2.e0*(1.e0/45.e0 - (IntPower(TT,2))/315.e0 + (IntPower(TT,4))/4725.e0)*
    IntPower(TT,3);
BETA  := 2.e0*(1.e0/3.e0 + (IntPower(TT,2))*(1.e0/15.e0 - (2.e0*IntPower(TT,2))/
    105.e0 + (IntPower(TT,4))/567.e0));
GAMA  := 4.e0/3.e0 - (IntPower(TT,2))*(2.e0/15.e0 - (IntPower(TT,2))/210.e0 +
    (IntPower(TT,4))/11340.e0);
_50:
C8  := 0.e0;
S8  := 0.e0;
C7  := 0.e0;
S7  := 0.e0;
CS0  := Cos(T*X0);
SN0  := Sin(T*X0);
for J:=1 to 16 do
 begin
  CS[J-1] := Cos(T*X[J-1]);
  SN[J-1] := Sin(T*X[J-1]);
_60:
 end;
J := 2;
while ( J<=6 ) do
 begin
  C8  := C8 + FR[J-1]*CS[J-1];
  S8  := S8 + FI[J-1]*SN[J-1];
_70:
  inc(J,2);
 end;
C8  := C8 + (FR0*CS0 + FR[7]*CS[7])/2.e0;
S8  := S8 + (FI0*SN0 + FI[7]*SN[7])/2.e0;
C16  := 0.e0;
S16  := 0.e0;
J := 10;
while ( J<=14 ) do
 begin
  C16  := C16 + FR[J-1]*CS[J-1];
  S16  := S16 + FI[J-1]*SN[J-1];
_80:
  inc(J,2);
 end;
C16  := C16 + (FR[7]*CS[7] + FR[15]*CS[15])/2.e0;
S16  := S16 + (FI[7]*SN[7] + FI[15]*SN[15])/2.e0;
C7  := 0.e0;
S7  := 0.e0;
J := 1;
while ( J<=7 ) do
 begin
  C7  := C7 + FR[J-1]*CS[J-1];
  S7  := S7 + FI[J-1]*SN[J-1];
_90:
  inc(J,2);
 end;
C15  := FR[8];
S15  := FI[8]*SN[8];
J := 11;
while ( J<=15 ) do
 begin
  C15  := C15 + FR[J-1]*CS[J-1];
  S15  := S15 + FI[J-1]*SN[J-1];
_100:
  inc(J,2);
 end;
QLEFT  := STEP*(ALFA*(FR[7]*SN[7] + FI[7]*CS[7] - FR0*SN0 -
    FI0*CS0) + BETA*(C8 - S8) + GAMA*(C7 - S7));
QRIGHT[LEV+0] := STEP*(ALFA*(FR[15]*SN[15] + FI[15]*CS[15] -
    FR[7]*SN[7] - FI[7]*CS[7]) + BETA*(C16 -
    S16) + GAMA*(C15 - S15));
QNOW  := QLEFT + QRIGHT[LEV+0];
QDIFF  := QNOW - QPREV;
AREA  := AREA + QDIFF;
ESTERR  := Abs(QDIFF)/7.e0;
TOLERR  := EMax1(ABSERR,RELERR*Abs(AREA))*(STEP/STONE);
if ( LEV  <  LEVMIN ) 
 then goto _110;
if ( LEV  >=  LEVMAX ) 
 then goto _150;
if ( NOFUN  >  NOFIN ) 
 then goto _140;
if ( ESTERR  <=  TOLERR ) 
 then goto _160;
_110:
NIM  := 2*NIM;
LEV  := LEV + 1;
for I:=1 to 8 do
 begin
  FRSAVE[(I-1)+(LEV-1)*8] := FR[I+7];
  FISAVE[(I-1)+(LEV-1)*8] := FI[I+7];
  XSAVE[(I-1)+(LEV-1)*8] := X[I+7];
_120:
 end;
QPREV  := QLEFT;
for I:=1 to 8 do
 begin
  J  := -I;
  FR[2*J+17] := FR[J+8];
  FI[2*J+17] := FI[J+8];
  X[2*J+17] := X[J+8];
_130:
 end;
goto _20;
_140:
NOFIN  := 2*NOFIN;
LEVMAX  := LEVOUT;
FLAG  := FLAG + (B - X0)/(B - A);
goto _160;
_150:
FLAG  := FLAG + 1.0e0;
_160:
RESULT_  := RESULT_ + QNOW;
ERREST  := ERREST + ESTERR;
COR11  := COR11 + QDIFF/7.e0;
_170:
//if ( NIM  =  2*(NIM div 2) ) // -  
if ( ( NIM mod 2 )=0 ) 
 then goto _180;
NIM  := NIM div 2;
LEV  := LEV - 1;
goto _170;
_180:
NIM  := NIM + 1;
if ( LEV  <=  0 ) 
 then goto _200;
QPREV  := QRIGHT[LEV-1];
X0  := X[15];
FR0  := FR[15];
FI0  := FI[15];
for I:=1 to 8 do
 begin
  FR[2*I-1] := FRSAVE[(I-1)+(LEV-1)*8];
  FI[2*I-1] := FISAVE[(I-1)+(LEV-1)*8];
  X[2*I-1] := XSAVE[(I-1)+(LEV-1)*8];
_190:
 end;
goto _20;
_200:
RESULT_  := RESULT_ + COR11;
if ( ERREST  =  0.e0 ) 
 then goto _220;
_210:
TEMP  := Abs(RESULT_) + ERREST;
if ( TEMP  <>  Abs(RESULT_) ) 
 then goto _220;
ERREST  := 2.0e0*ERREST;
goto _210;
_220:
end;

end.
